package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.context.VariableContext;
import org.bitbucket.bradleysmithllc.etlunit.feature.AbstractFeature;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestOperation;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestVariable;

public class ContextFeatureModule extends AbstractFeature
{
	private final class ContextListener extends NullClassListener
	{
		@Override
		public void declare(ETLTestVariable var, VariableContext context)
		{
			// just pass on the declare to the context
			context.declareVariable(var.getName());

			// set the value
			context.setValue(var.getName(), var.getValue());
		}

		// Provide a set variable method
		@Override
		public action_code process(ETLTestOperation op, ETLTestValueObject obj, VariableContext context, ExecutionContext econtext)
				throws TestAssertionFailure, TestExecutionError, TestWarning
		{
			if (op.getOperationName().equals("set"))
			{
				context.declareAndSetValue(obj.query("variable").getValueAsString(), obj.query("value"));

				return action_code.handled;
			}

			return action_code.defer;
		}
	}

	private final ContextListener contextListener = new ContextListener();

	@Override
	public String getFeatureName()
	{
		return "context";
	}

	@Override
	public ClassListener getListener()
	{
		return contextListener;
	}
}