package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.context.VariableContext;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestMethod;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestOperation;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;

import javax.annotation.Nullable;
import java.util.List;

public class OperationProcessorSpammer implements OperationProcessor
{
	private final List<OperationProcessor> processors;

	public OperationProcessorSpammer(List<OperationProcessor> processors)
	{
		this.processors = processors;
	}

	@Override
	public action_code process(@Nullable ETLTestMethod mt, ETLTestOperation op, ETLTestValueObject parameters, VariableContext vcontext, ExecutionContext econtext) throws TestAssertionFailure, TestExecutionError, TestWarning
	{
		for (OperationProcessor processor : processors)
		{
			action_code actionCode = processor.process(mt, op, parameters, vcontext, econtext);
			if (actionCode != action_code.defer)
			{
				return actionCode;
			}
		}

		return action_code.defer;
	}
}
